openapi: 3.0.0
# TODO: phần execute, set status, hỏi lại một số trường, 
# TODO: hỏi lại về việc spec description đầy đủ luồng
# TODO: Cần kiểm tra lại, có thể sót lỗi đã bị quên
info:
  description: "This is a API of Lilog to read and write data from the database to server the system's frontend."
  version: "1.0.0"
  title: "Lilog API Sale Quotation"
  termsOfService: "http://swagger.io/terms/"
  contact:
    email: "quochieu.ipcoms@gmail.com"
  license:
    name: "Apache 2.0"
    url: "http://www.apache.org/licenses/LICENSE-2.0.html"

tags:
- name: "Sale.Quotation"
  description: "Retriving, uploading the data about the sale/quotations model"
  externalDocs:
    description: "Find out more"
    url: "lilog.ipcoms.tk/system/model"
    
paths:
  /search:
    post:
      summary: "Get data from Sale.Quotation with or without conditions"
      tags: 
        - Sale.Quotation
      requestBody:
        content:
          application/json:
            schema:
                $ref: '#/components/schemas/Sale.Quotation.Payload.Search'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Sale.Quotation.Response.Search'
  /execute:
    post:
      summary: "get search field from Sale.Quotation database"
      tags: 
        - Sale.Quotation
      requestBody:
        content:
          application/json:
            schema:
                $ref: '#/components/schemas/Sale.Quotation.Payload.Execute'

      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                  $ref: '#/components/schemas/Sale.Quotation.Response.Execute'
  /write:
    post:
      summary: "Write data to Sale.Quotation database"
      tags: 
        - Sale.Quotation
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Sale.Quotation.Payload.Write'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                  $ref: '#/components/schemas/Sale.Quotation.Response.Write'
  /read:
    post:
      summary: "get data to Sale.Quotation database"
      tags: 
        - Sale.Quotation
      requestBody:
        content:
          application/json:
            schema:
                $ref: '#/components/schemas/Sale.Quotation.Payload.Read'

      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                  $ref: '#/components/schemas/Sale.Quotation.Response.Read'

  /delete:
    post:
      summary: "delete data to Sale.Quotation database"
      tags: 
        - Sale.Quotation
      requestBody:
        content:
          application/json:
            schema:
                $ref: '#/components/schemas/Sale.Quotation.Payload.Delete'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema: 
                $ref: '#/components/schemas/Sale.Quotation.Response.Delete'   
components:
  schemas:
    Sale.Quotation.Payload.Search:
      type: object
      properties:
        model:
          type: string
          default: "sale.quotation"
        domains:
          type: array
          description: điều kiện trả về data của Sale.Quotation, ở dưới dạng 2d Array có phần tử dưới dạng (điều kiện, toán tử, query)
          items: 
            oneOf:
            - type: string
              description: tìm kiếm với tên trên thanh tìm kiếm
              default: "|"
            - type: array
              description: điều kiện tìm kiếm
              items: 
                oneOf:
                  - type: string
                    description: điều kiện
                  - type: string
                    description: toán tử
                  - oneOf:
                      - type: string
                      - type: integer
                    description: nhập thông tin lọc
                    
              maxItems: 3
            default:  [
              [
              "sale_quotation.created_at",
              "<",
              "2021-12-09T16:59:59.999Z"
              ]
            ]
        options:
          type: object
          properties:
            includes:
              type: array
              items:
                type: string
              default:
                [
                   "owner",
                   "customer"
                ]
            fields:
              type: array
              items:
                type: string
              default:
                [
                "sale_quotation.*",
                "owner.name",
                "customer.name"
                ]
        page:
          type: integer
          description: chỉ dấu trang data cần hiện thị
          default: 1
        perpage:
          type: integer
          description: số lượng elements mỗi trang
          default: 20
    Sale.Quotation.Response.Search:
      type: object
      properties:
        data: 
          type: array
          description: data của các phiếu báo giá được trả về
          items:
            type: object
            properties: 
              id:
                type: integer
                description: id
                default: 240
              customer:
                type: integer
                description: mã khách hàng
                default: 13334
              status:
                type: integer
                description: trạng thái 
                default: 1
              code:
                type: string
                description: mã báo giá
                default: "BG-0305"
              created_by:
                type: string
                description: tạo bởi
                default: "hieunq" 
              owner:
                type: integer
                description: Mã chủ hàng
                default: 54
              notes:
                type: string
                description: s
                default: null
              
              updated_at:
                type: string
                description: thời gian cập nhật
              created_at:
                type: string
                description: thời gian tạo
              effective_days:
                type: integer
                default: 56
                description: có hiệu lực đến
              sale_price:
                type: integer
                default: 1
                description: chịu :))
              discount:
                type: integer
                default: 9
                description: giảm giá
              discount_rate:
                type: string
                default: null
                description: tỉ lệ giảm giá
              owner_name:
                type: string
                default: "TESTING"
                description: "tên chủ hàng"
              customer_name:
                type: string
                default: "test đặt cọc"
                description: "tên khách hàng"
              status_text:
                type: string
                default: "Mới"
                description: Mã trạng thái
        meta:
          type: object
          properties:
            page:
              type: integer
              description: chỉ mục trang
              default: 1
            pages:
              type: integer
              description: tổng số trang
              default: 5
            perpage:
              type: integer
              description: số phần tử mỗi trang
              default: 20
            total:
              type: integer
              description: tổng số phần tử
              default: 93             
    Sale.Quotation.Payload.Write:
      type: object
      properties:
        model:
          type: string
          description: "gọi đến model báo giá trong phần bán hàng"
          default: sale.quotation
        args:
          type: object
          properties:
            status:
              type: integer
              description: s
              default: 1
            code:
              type: string
              description: s
              default: "Mới"
            lines:
              type: array
              items:
                type: object
                properties:
                  price:
                    type: integer
                    default: 250000
                  selected:
                    type: boolean
                    default: false
                  vat:
                    type: integer
                    default: 0
                  edit:
                    type: boolean
                    default: true
                  product:
                    type: integer
                    default: 17030
                  unit: 
                    type: integer
                    default: 102
                  product_code:
                    type: string
                    default: 
                  product_name:
                    type: string
                    default:
                  product_display_name:
                    type: string
                    default:
                  quantity:
                    type: integer
                    default: 1
                  discount:
                    type: integer
                    default: 2500
                  discount_rate:
                    type: integer
                    default: 1
            next_status:
              type: array
              items:
                type: string
              default: []
            _editable:
              type: boolean
              default: true
            owner:
              type: integer
              default: 54
            sale_price:
              type: integer
              default: 6
            customer:
              type: integer
              default: 13334
            effective_days:
              type: integer
              default: 12
            discount_rate:
              type: string
              default: "10"
            discount:
              type: integer
              default: 24750
                
    Sale.Quotation.Response.Write:
      type: object
      properties:
        ok:
         type: boolean
         default: true
        message: 
          type: string
          description: s
        result:
          type: object
          properties:
            id:
              type: integer
              description: s
            meta:
              type: object
              properties:
                row_count:
                  type: integer
                  description: s
                  default: 1
                is_update:
                  type: boolean
                  description: s
                  default: false
                changed: 
                  type: array
                  items:
                    type: string
                  default: []
            model: 
              type: string
              default: "sale.quotation"
              description: s
    Sale.Quotation.Payload.Delete:
      type: object
      description: s
      properties: 
        model: 
          type: string
          default: "sale.quotation"
          description: s
        ids:
          type: array
          description: s
          items:
            type: integer
            default: 239
    Sale.Quotation.Response.Delete:
      type: object
      properties:
        ok:
         type: boolean
        message:
          type: string
          description: s
          default: "1 record deleted"
    Sale.Quotation.Payload.Read:
      type: object
      properties: 
        model: 
          type: string
          default: "sale.quotation"
          description: s
        ids:
          type: integer
          description: s
          default: 240
    Sale.Quotation.Response.Read:
      type: object
      properties: 
        id:
          type: integer
          description: id
          default: 240
        customer:
          type: integer
          description: mã báo giá
          default: 13334
        status:
          type: integer
          description: trạng thái 
          default: 1
        code:
          type: string
          description: mã báo giá
          default: "BG-0305"
        created_by:
          type: string
          description: tạo bởi
          default: "hieunq" 
        owner:
          type: integer
          description: Mã chủ hàng
          default: 54
        notes:
          type: string
          description: s
          default: null
        
        updated_at:
          type: string
          description: thời gian cập nhật
        created_at:
          type: string
          description: thời gian tạo
        effective_days:
          type: integer
          default: 56
          description: có hiệu lực đến
        discount: 
          type: integer
          default: 9
        discount_rate:
          type: string
          default: null
        status_text:
          type: string
          default: "Mới"
        _editable:
          type: boolean
          default: true
        lines:
          type: array
          items:
            type: object
            properties:
              id:
                type: integer
                default: 194
              quotation:
                type: integer
                default: 240
              product:
                type: integer
                default: 17024
              qty_base:
                type: integer
                default: 4
              price:
                type: integer
                default: 111
              owner:
                type: integer
                default: 54
              unit:
                type: integer
                default: 127
              notes: 
                type: string
                default: null
              vat:
                type: integer
                default: 5
              updated_at:
                type: string
                default: "2021-12-08T12:39:27.670Z"
              created_at:
                type: string
                default: "2021-12-08T12:39:27.670Z"
              discount:
                type: number
                default: 5.55
              product_code:
                type: string
                default: "TAOAM249"
              product_name:
                type: string
                default: "Táo Ambrosia size 24 - thùng 9kg (Kg)"
              unit_display_name:
                type: string
                default: "Gram"
        next_status:
          type: array
          items:
            type: object
            properties:
              id:
                type: integer
                default: 20
              text:
                type: string
                default: "Đã duyệt"
        orders:
          type: array
          items:
            type: string
          default: []            
    Sale.Quotation.Payload.Execute:
      type: object
      properties:
        model:
          type: string
          default: "sale.quotation"
        method:
          type: string
          enum: ["get_fields", "set_status"]
        args:
          type: array
          items: 
            type: object
          description: s
          default: []
    Sale.Quotation.Response.Execute:
      type: object
      properties: 
        ok:
         type: boolean
         description: s
         default: true
        message: 
          type: string
          description: s
          default: "Thành công!"
        result:
          type: array
          items: 
            type: object
            properties:
              name:
                type: string
                description: s
                default: "id"
              fullname:
                type: string
                description: s
                default: "sale_quotation.id"
              label:
                type: string
                description: s
                default: "ID"        
              datatype:
                type: string
                description: s
                default: "serial" 
     
        
         